import matplotlib.pyplot as plt
import networkx as nx
colors = ['firebrick', 'springgreen', 'burlywood', 'oldlace', 'lightgoldenrodyellow', 'grey', 'cyan', 'crimson', 'mediumvioletred', 'maroon', 'mediumturquoise', 'teal', 'azure', 'palevioletred', 'mediumslateblue', 'olivedrab', 'darkred', 'dimgrey', 'lightgreen', 'blueviolet', 'chartreuse', 'whitesmoke', 'mediumspringgreen', 'yellowgreen', 'green', 'darkorchid', 'lawngreen', 'black', 'darkgoldenrod', 'moccasin', 'seashell', 'orange', 'slateblue', 'hotpink', 'tan', 'darkolivegreen', 'mediumorchid', 'darkgreen', 'navajowhite', 'khaki', 'paleturquoise', 'darkgray', 'darkorange', 'salmon', 'floralwhite', 'lightgray', 'darkblue', 'lightslategray', 'darkslateblue', 'goldenrod', 'lightcyan', 'papayawhip', 'wheat', 'lightslategrey', 'darksalmon', 'skyblue', 'violet', 'coral', 'mediumseagreen', 'darkmagenta', 'palegreen', 'magenta', 'lavenderblush', 'darkkhaki', 'darkturquoise', 'lightsalmon', 'blanchedalmond', 'deepskyblue', 'mediumaquamarine', 'mintcream', 'lightyellow', 'linen', 'peachpuff', 'aliceblue', 'gold', 'ghostwhite', 'silver', 'bisque', 'aquamarine', 'lightblue', 'lavender', 'antiquewhite', 'dimgray', 'lightskyblue', 'pink', 'beige', 'indianred', 'rosybrown', 'rebeccapurple', 'lightgrey', 'powderblue', 'chocolate', 'darkgrey', 'purple', 'darkslategrey', 'cornsilk', 'turquoise', 'blue', 'greenyellow', 'red', 'lime', 'ivory', 'royalblue', 'palegoldenrod', 'lightsteelblue', 'slategray', 'gray', 'brown', 'mistyrose', 'cornflowerblue', 'tomato', 'indigo', 'snow', 'darkslategray', 'lightpink', 'darkviolet', 'limegreen', 'honeydew', 'yellow', 'sienna', 'mediumblue', 'fuchsia', 'forestgreen', 'orchid', 'plum', 'lemonchiffon', 'gainsboro', 'sandybrown', 'slategrey', 'mediumpurple', 'saddlebrown', 'lightcoral', 'midnightblue', 'navy', 'thistle', 'dodgerblue', 'lightseagreen', 'darkseagreen', 'cadetblue', 'seagreen', 'darkcyan', 'steelblue', 'white', 'peru', 'deeppink', 'olive', 'firebrick', 'aqua', 'orangered']

# {0: 0, 1: 0, 2: 0, 3: 0, 4: 0, 5: 0, 6: 0, 7: 0, 8: 0, 9: 0, 10: 1, 11: 1, 12: 1, 13: 1, 14: 1, 15: 1, 16: 1, 17: 1, 18: 1, 19: 1, 20: 1, 21: 1, 22: 1, 23: 1, 24: 1, 25: 1, 26: 1, 27: 1, 28: 1, 29: 1, 30: 2, 31: 2, 32: 2, 33: 2, 34: 2, 35: 2, 36: 2, 37: 2, 38: 2, 39: 2, 40: 2, 41: 2, 42: 2, 43: 2, 44: 2, 45: 2, 46: 2, 47: 2, 48: 2, 49: 2, 50: 2, 51: 2, 52: 2, 53: 2, 54: 2, 55: 2, 56: 2, 57: 2, 58: 2, 59: 2, 60: 3, 61: 3, 62: 3, 63: 3, 64: 3, 65: 3, 66: 3, 67: 3, 68: 3, 69: 3, 70: 3, 71: 3, 72: 3, 73: 3, 74: 3, 75: 3, 76: 3, 77: 3, 78: 3, 79: 3, 80: 3, 81: 3, 82: 3, 83: 3, 84: 3, 85: 3, 86: 3, 87: 3, 88: 3, 89: 3, 90: 3, 91: 3, 92: 3, 93: 3, 94: 3, 95: 3, 96: 3, 97: 3, 98: 3, 99: 3}
# {0: 'tab:blue', 1: 'tab:blue', 2: 'tab:blue', 3: 'tab:blue', 4: 'tab:blue', 5: 'tab:blue', 6: 'tab:blue', 7: 'tab:blue', 8: 'tab:blue', 9: 'tab:blue', 10: 'tab:orange', 11: 'tab:orange', 12: 'tab:orange', 13: 'tab:orange', 14: 'tab:orange', 15: 'tab:orange', 16: 'tab:orange', 17: 'tab:orange', 18: 'tab:orange', 19: 'tab:orange', 20: 'tab:orange', 21: 'tab:orange', 22: 'tab:orange', 23: 'tab:orange', 24: 'tab:orange', 25: 'tab:orange', 26: 'tab:orange', 27: 'tab:orange', 28: 'tab:orange', 29: 'tab:orange', 30: 'tab:green', 31: 'tab:green', 32: 'tab:green', 33: 'tab:green', 34: 'tab:green', 35: 'tab:green', 36: 'tab:green', 37: 'tab:green', 38: 'tab:green', 39: 'tab:green', 40: 'tab:green', 41: 'tab:green', 42: 'tab:green', 43: 'tab:green', 44: 'tab:green', 45: 'tab:green', 46: 'tab:green', 47: 'tab:green', 48: 'tab:green', 49: 'tab:green', 50: 'tab:green', 51: 'tab:green', 52: 'tab:green', 53: 'tab:green', 54: 'tab:green', 55: 'tab:green', 56: 'tab:green', 57: 'tab:green', 58: 'tab:green', 59: 'tab:green', 60: 'tab:red', 61: 'tab:red', 62: 'tab:red', 63: 'tab:red', 64: 'tab:red', 65: 'tab:red', 66: 'tab:red', 67: 'tab:red', 68: 'tab:red', 69: 'tab:red', 70: 'tab:red', 71: 'tab:red', 72: 'tab:red', 73: 'tab:red', 74: 'tab:red', 75: 'tab:red', 76: 'tab:red', 77: 'tab:red', 78: 'tab:red', 79: 'tab:red', 80: 'tab:red', 81: 'tab:red', 82: 'tab:red', 83: 'tab:red', 84: 'tab:red', 85: 'tab:red', 86: 'tab:red', 87: 'tab:red', 88: 'tab:red', 89: 'tab:red', 90: 'tab:red', 91: 'tab:red', 92: 'tab:red', 93: 'tab:red', 94: 'tab:red', 95: 'tab:red', 96: 'tab:red', 97: 'tab:red', 98: 'tab:red', 99: 'tab:red'}

partition_sizes = [60, 10, 22, 60, 20, 30, 30, 10, 10]
# g = nx.random_partition_graph(partition_sizes, 0.5, 0.1)
# print(g.edges)
po = {0: 'TGCGGTTGA', 1: 'ACCGGTTAA', 2: 'TACGGTTAA', 3: 'GTAGGTTGA', 4: 'GCCGGTTAA', 5: 'TGAGGTTGA', 6: 'TAGGGTTTG', 7: 'CCAGGTTGA', 8: 'TTGGGTTGA', 9: 'TACGGTTGA', 10: 'TGGGGTTGA', 11: 'GCGGGTTGA', 12: 'CCGGGTTTG', 13: 'ACGGGTTGA', 14: 'GTTGGTTGA', 15: 'CGAGGTTAA', 16: 'AAGGGTTGA', 17: 'GGCGGTTAA', 18: 'GTGGGTTGA', 19: 'TTTGGTTTA', 20: 'TAGGGTTGA', 21: 'GCTGGTTGA', 22: 'GCCGGTTGA', 23: 'TTCGGTTAA', 24: 'TGGGGTTAT', 25: 'GGCGGTTGA', 26: 'TCCGGTTAA', 27: 'GTTGGTTAA', 28: 'GATGGTTAA', 29: 'ACAGGTTAG', 30: 'CTGGGTTGA', 31: 'GATGGTTGA', 32: 'CACGGTTAG', 33: 'TATGGTTGA', 34: 'TAGGGTTTA', 35: 'TATGGTTTA', 36: 'TTAGGTTGA', 37: 'GAGGGTTGA', 38: 'TAAGGTTGA', 39: 'AATGGTTAA', 40: 'GGTGGTTTG', 41: 'ATGGGTTGA', 42: 'ATAGGTTGA', 43: 'ATTGGTTGA', 44: 'AATGGTTGA', 45: 'TCAGGTTAG', 46: 'AACGGTTAT', 47: 'AACGGTTGA', 48: 'TACGGTTAG', 49: 'GGGGGTTGA', 50: 'CTTGGTTGA', 51: 'TGTGGTTGA', 52: 'TGCGGTTCG', 53: 'AGTGGTTGA', 54: 'TAGGGTTAA', 55: 'TCAGGTTGA', 56: 'TGCGGTTAA', 57: 'TGAGGTTTC', 58: 'TATGGTTGG', 59: 'AGAGGTTGA', 60: 'TGTGGTTGT', 61: 'TCCGGTTGG', 62: 'CCTGGTTCG', 63: 'TCAGGTTGG', 64: 'TCAGGTTAA', 65: 'CCCGGTTGA', 66: 'TCGGGTTGG', 67: 'GGCGGTTGG', 68: 'ATGGGTTTA', 69: 'TCCGGTTGA', 70: 'CAAGGTTAA', 71: 'AAAGGTTGA', 72: 'AAGGGTTTC', 73: 'TGCGGTTAC', 74: 'CCAGGTTCA', 75: 'AGGGGTTGA', 76: 'AGTGGTTTA', 77: 'GTGGGTTAG', 78: 'ATCGGTTCC', 79: 'AGCGGTTGA', 80: 'CTCGGTTGA', 81: 'TTCGGTTGA', 82: 'CAAGGTTGA', 83: 'TCCGGTTCG', 84: 'ATAGGTTTC', 85: 'ACCGGTTTT', 86: 'CTTGGTTAT', 87: 'GGGGGTTTA', 88: 'GTCGGTTAG', 89: 'ATCGGTTTT', 90: 'ATCGGTTGA', 91: 'CGCGGTTGA', 92: 'TCCGGTTCT', 93: 'TCTGGTTGA', 94: 'TGTGGTTAA', 95: 'TCAGGTTTA', 96: 'CCGGGTTGA', 97: 'TTCGGTTAC', 98: 'AACGGTTAA', 99: 'TCCGGTTAT', 100: 'AAGGGTTTA', 101: 'CTCGGTTGT', 102: 'TCTGGTTAA', 103: 'TCCGGTTCA', 104: 'ATCGGTTAA', 105: 'TTCGGTTAG', 106: 'ATGGGTTAG', 107: 'AAGGGTTAT', 108: 'GTCGGTTGG', 109: 'ACCGGTTGG', 110: 'TGCGGTTGG', 111: 'GGCGGTTAG', 112: 'TTGGGTTCT', 113: 'AACGGTTCA', 114: 'AAAGGTTTA', 115: 'CGGGGTTGA', 116: 'TAAGGTTCG', 117: 'GGTGGTTAG', 118: 'GTTGGTTCA', 119: 'GGTGGTTGA', 120: 'TACGGTTGT', 121: 'TGTGGTTAT', 122: 'ACCGGTTGA', 123: 'TCGGGTTAG', 124: 'CACGGTTTT', 125: 'GACGGTTAC', 126: 'TCCGGTTTA', 127: 'TGAGGTTAA', 128: 'CAAGGTTGG', 129: 'CATGGTTGA', 130: 'AGTGGTTCT', 131: 'CGTGGTTAG', 132: 'ATAGGTTAA', 133: 'AGTGGTTAA', 134: 'TAGGGTTTC', 135: 'CTGGGTTAA', 136: 'TAGGGTTGC', 137: 'TTAGGTTTA', 138: 'CTCGGTTAA', 139: 'TAAGGTTTA', 140: 'AAGGGTTAA', 141: 'AGCGGTTAG', 142: 'TTAGGTTCC', 143: 'ATCGGTTTA', 144: 'CAGGGTTGA', 145: 'TAAGGTTGG', 146: 'GGAGGTTGA', 147: 'TGCGGTTAT', 148: 'GGAGGTTCT', 149: 'TAGGGTTAG', 150: 'TGGGGTTAG', 151: 'ATAGGTTCA', 152: 'TGCGGTTTG', 153: 'TGGGGTTGC', 154: 'GACGGTTAG', 155: 'AATGGTTAT', 156: 'TCCGGTTAC', 157: 'AAAGGTTGC', 158: 'GTCGGTTAA', 159: 'CACGGTTGA', 160: 'CAGGGTTTA', 161: 'AGCGGTTTA', 162: 'ATGGGTTAA', 163: 'TTGGGTTAC', 164: 'TCGGGTTTA', 165: 'GCAGGTTGA', 166: 'TCGGGTTGA', 167: 'TGAGGTTAT', 168: 'GCAGGTTTA', 169: 'TCTGGTTTG', 170: 'TGCGGTTAG', 171: 'GATGGTTTA', 172: 'TGAGGTTCA', 173: 'ACAGGTTGG', 174: 'ATCGGTTAT', 175: 'TCTGGTTAG', 176: 'AAAGGTTGG', 177: 'AGCGGTTAA', 178: 'CCTGGTTGA', 179: 'CAAGGTTAG', 180: 'TCTGGTTAT', 181: 'ATTGGTTAG', 182: 'TTTGGTTGA', 183: 'TTAGGTTCG', 184: 'ACGGGTTAA', 185: 'CCAGGTTTG', 186: 'TAAGGTTCC', 187: 'CTCGGTTGG', 188: 'GACGGTTTA', 189: 'GGCGGTTCA', 190: 'TAGGGTTCG', 191: 'AGGGGTTAA', 192: 'TGTGGTTAC', 193: 'ACGGGTTTC', 194: 'TCCGGTTGT', 195: 'CCGGGTTCA', 196: 'TGTGGTTTA', 197: 'TGAGGTTAG', 198: 'AGCGGTTTT', 199: 'TGGGGTTAA', 200: 'AAAGGTTAA', 201: 'GAGGGTTAC', 202: 'GACGGTTCA', 203: 'TCCGGTTTC', 204: 'TCCGGTTAG', 205: 'AGAGGTTAA', 206: 'TAAGGTTCA', 207: 'ACTGGTTGA', 208: 'TTCGGTTAT', 209: 'TTAGGTTAA', 210: 'TTAGGTTCT', 211: 'GGAGGTTGT', 212: 'GATGGTTGC', 213: 'AATGGTTCT', 214: 'TCAGGTTTT', 215: 'TGCGGTTTC', 216: 'GCCGGTTGG', 217: 'TGAGGTTTT', 218: 'CCCGGTTTC', 219: 'AAAGGTTTG', 220: 'ATGGGTTCA', 221: 'GACGGTTGA', 222: 'TACGGTTTG', 223: 'TACGGTTTA', 224: 'TGTGGTTTT', 225: 'TCGGGTTGT', 226: 'CCGGGTTGC', 227: 'TCAGGTTCA', 228: 'CCTGGTTAA', 229: 'CGCGGTTAA', 230: 'AAAGGTTAG', 231: 'TTCGGTTCA', 232: 'ATAGGTTGC', 233: 'CGTGGTTTA', 234: 'CGGGGTTAC', 235: 'GATGGTTCG', 236: 'ACCGGTTGT', 237: 'GCGGGTTAA', 238: 'CCCGGTTAA', 239: 'AAAGGTTAT', 240: 'CTAGGTTAA', 241: 'AAGGGTTGC', 242: 'TTAGGTTTT', 243: 'TGAGGTTTG', 244: 'TCGGGTTAA', 245: 'CCGGGTTGT', 246: 'ATCGGTTTG', 247: 'AACGGTTAG', 248: 'AACGGTTTA', 249: 'CCAGGTTAC', 250: 'AATGGTTTT', 251: 'ACCGGTTTA'}
g = nx.Graph()
g.add_nodes_from([i for i in range(252)])
# g.add_edges_from([(0, 1), (0, 2), (0, 4), (0, 7), (0, 9), (0, 39), (0, 64), (0, 65), (0, 72), (0, 79), (0, 82), (0, 88), (0, 98), (1, 3), (1, 4), (1, 5), (1, 7), (1, 8), (1, 18), (1, 26), (1, 28), (1, 41), (1, 56), (1, 71), (1, 98), (2, 3), (2, 5), (2, 7), (2, 9), (2, 19), (2, 23), (2, 47), (2, 50), (2, 58), (2, 64), (2, 75), (2, 99), (3, 5), (3, 6), (3, 7), (3, 32), (3, 33), (3, 50), (3, 53), (3, 54), (3, 61), (3, 68), (3, 84), (3, 94), (3, 99), (4, 6), (4, 30), (4, 48), (4, 49), (4, 66), (4, 67), (4, 93), (5, 6), (5, 15), (5, 19), (5, 46), (5, 59), (5, 65), (5, 70), (6, 7), (6, 9), (6, 37), (6, 38), (6, 53), (6, 57), (6, 62), (6, 65), (6, 75), (6, 76), (6, 83), (7, 8), (7, 9), (7, 14), (7, 25), (7, 33), (7, 51), (7, 70), (7, 77), (8, 20), (8, 21), (8, 28), (8, 31), (8, 40), (8, 42), (8, 52), (8, 54), (8, 70), (8, 97), (9, 23), (9, 40), (9, 43), (9, 49), (9, 51), (9, 68), (9, 76), (10, 12), (10, 13), (10, 14), (10, 16), (10, 17), (10, 20), (10, 23), (10, 24), (10, 25), (10, 26), (10, 28), (10, 44), (10, 61), (10, 63), (11, 13), (11, 14), (11, 15), (11, 16), (11, 17), (11, 18), (11, 19), (11, 20), (11, 23), (11, 28), (11, 29), (11, 33), (11, 51), (11, 70), (11, 84), (12, 17), (12, 18), (12, 19), (12, 22), (12, 23), (12, 27), (12, 28), (12, 31), (12, 34), (12, 59), (12, 79), (12, 80), (12, 83), (12, 97), (12, 99), (13, 14), (13, 16), (13, 21), (13, 23), (13, 27), (13, 59), (13, 81), (14, 15), (14, 17), (14, 22), (14, 23), (14, 24), (14, 26), (14, 27), (14, 34), (14, 55), (14, 58), (14, 59), (14, 63), (14, 65), (14, 75), (14, 76), (14, 97), (15, 17), (15, 18), (15, 19), (15, 20), (15, 41), (15, 45), (15, 52), (15, 67), (15, 72), (15, 92), (16, 17), (16, 19), (16, 20), (16, 23), (16, 27), (16, 28), (16, 35), (16, 47), (16, 56), (16, 77), (16, 88), (16, 90), (16, 94), (17, 19), (17, 21), (17, 23), (17, 25), (17, 26), (17, 27), (17, 32), (17, 56), (17, 61), (17, 76), (17, 78), (17, 93), (18, 20), (18, 21), (18, 22), (18, 24), (18, 25), (18, 47), (18, 65), (18, 72), (18, 96), (19, 20), (19, 23), (19, 24), (19, 25), (19, 27), (19, 28), (19, 29), (19, 40), (19, 70), (19, 90), (19, 93), (20, 22), (20, 24), (20, 25), (20, 27), (20, 28), (20, 30), (20, 36), (20, 57), (20, 60), (20, 88), (21, 22), (21, 23), (21, 25), (21, 32), (21, 40), (21, 47), (21, 59), (21, 67), (21, 72), (21, 75), (21, 76), (21, 93), (21, 95), (22, 23), (22, 24), (22, 25), (22, 26), (22, 28), (22, 31), (22, 33), (22, 37), (22, 43), (22, 50), (22, 58), (22, 67), (22, 76), (22, 90), (22, 97), (23, 48), (23, 57), (23, 70), (23, 76), (23, 78), (23, 82), (23, 88), (23, 89), (24, 27), (24, 28), (24, 29), (24, 40), (24, 51), (24, 62), (24, 68), (24, 95), (25, 26), (25, 37), (25, 58), (25, 59), (25, 65), (25, 70), (25, 73), (25, 78), (25, 82), (25, 97), (26, 43), (26, 50), (26, 55), (26, 58), (26, 64), (26, 68), (26, 77), (27, 28), (27, 29), (27, 47), (27, 60), (27, 76), (27, 92), (28, 29), (28, 58), (28, 59), (28, 60), (28, 72), (28, 82), (28, 83), (28, 86), (28, 93), (28, 99), (29, 33), (29, 34), (29, 39), (29, 56), (29, 64), (29, 65), (29, 72), (30, 32), (30, 34), (30, 40), (30, 41), (30, 42), (30, 44), (30, 45), (30, 55), (30, 56), (30, 58), (30, 59), (30, 66), (30, 67), (30, 80), (30, 81), (30, 89), (31, 33), (31, 34), (31, 36), (31, 39), (31, 40), (31, 42), (31, 48), (31, 49), (31, 50), (31, 51), (31, 52), (31, 53), (31, 54), (31, 57), (31, 58), (31, 59), (31, 62), (31, 68), (31, 69), (31, 81), (31, 85), (31, 89), (31, 90), (31, 94), (32, 34), (32, 35), (32, 39), (32, 43), (32, 46), (32, 50), (32, 51), (32, 52), (32, 54), (32, 56), (32, 58), (32, 68), (32, 96), (32, 97), (33, 36), (33, 38), (33, 40), (33, 42), (33, 43), (33, 44), (33, 45), (33, 46), (33, 48), (33, 50), (33, 53), (33, 56), (33, 58), (33, 62), (33, 67), (33, 68), (33, 81), (33, 83), (34, 35), (34, 36), (34, 42), (34, 47), (34, 48), (34, 49), (34, 50), (34, 51), (34, 52), (34, 53), (34, 55), (34, 63), (34, 65), (34, 72), (34, 76), (34, 84), (34, 94), (34, 96), (35, 36), (35, 37), (35, 40), (35, 41), (35, 45), (35, 46), (35, 47), (35, 50), (35, 51), (35, 53), (35, 54), (35, 55), (35, 58), (35, 59), (35, 98), (36, 38), (36, 39), (36, 43), (36, 48), (36, 49), (36, 50), (36, 51), (36, 55), (36, 56), (36, 58), (36, 59), (36, 68), (36, 97), (37, 40), (37, 43), (37, 45), (37, 47), (37, 48), (37, 50), (37, 51), (37, 55), (37, 57), (37, 60), (37, 86), (37, 96), (38, 42), (38, 44), (38, 46), (38, 47), (38, 48), (38, 50), (38, 51), (38, 54), (38, 55), (38, 57), (38, 59), (38, 65), (38, 66), (38, 80), (38, 86), (38, 87), (39, 40), (39, 42), (39, 43), (39, 46), (39, 47), (39, 48), (39, 50), (39, 52), (39, 53), (39, 54), (39, 58), (39, 59), (39, 74), (39, 75), (39, 88), (40, 42), (40, 45), (40, 47), (40, 48), (40, 50), (40, 51), (40, 56), (40, 60), (40, 66), (40, 68), (40, 69), (40, 88), (40, 95), (40, 97), (41, 45), (41, 49), (41, 50), (41, 51), (41, 52), (41, 53), (41, 54), (41, 55), (41, 59), (41, 67), (41, 70), (41, 76), (41, 90), (41, 92), (42, 45), (42, 48), (42, 49), (42, 58), (42, 59), (42, 61), (42, 69), (42, 75), (42, 77), (42, 94), (42, 95), (43, 46), (43, 47), (43, 48), (43, 49), (43, 55), (43, 58), (43, 59), (43, 61), (43, 74), (43, 85), (43, 94), (43, 96), (44, 45), (44, 49), (44, 52), (44, 55), (44, 56), (44, 65), (44, 76), (44, 91), (45, 47), (45, 54), (45, 55), (45, 58), (45, 64), (45, 76), (45, 83), (45, 96), (45, 97), (46, 47), (46, 48), (46, 51), (46, 54), (46, 55), (46, 56), (46, 58), (46, 59), (46, 63), (46, 66), (46, 70), (46, 74), (46, 77), (46, 78), (46, 80), (46, 85), (46, 96), (47, 49), (47, 50), (47, 55), (47, 56), (47, 58), (47, 63), (47, 76), (47, 82), (47, 85), (47, 96), (48, 49), (48, 52), (48, 54), (48, 58), (48, 59), (48, 70), (48, 75), (48, 80), (48, 83), (48, 88), (49, 50), (49, 54), (49, 55), (49, 57), (49, 58), (49, 59), (49, 68), (49, 88), (49, 89), (49, 92), (50, 52), (50, 53), (50, 54), (50, 55), (50, 57), (50, 58), (50, 94), (51, 56), (51, 57), (51, 58), (51, 84), (52, 54), (52, 56), (52, 68), (52, 71), (52, 75), (52, 76), (52, 97), (53, 54), (53, 56), (53, 57), (53, 58), (53, 66), (53, 82), (54, 55), (54, 56), (54, 57), (54, 58), (54, 60), (54, 65), (54, 82), (55, 57), (55, 59), (55, 63), (55, 94), (56, 69), (56, 80), (56, 86), (57, 59), (57, 83), (57, 92), (57, 96), (57, 97), (58, 59), (58, 99), (59, 81), (59, 95), (60, 61), (60, 64), (60, 65), (60, 66), (60, 69), (60, 71), (60, 74), (60, 75), (60, 76), (60, 78), (60, 82), (60, 85), (60, 86), (60, 88), (60, 90), (60, 91), (60, 92), (60, 93), (60, 95), (60, 97), (60, 99), (61, 64), (61, 66), (61, 69), (61, 71), (61, 76), (61, 77), (61, 78), (61, 84), (61, 85), (61, 86), (61, 89), (61, 91), (61, 92), (61, 98), (61, 99), (62, 64), (62, 66), (62, 68), (62, 71), (62, 74), (62, 79), (62, 81), (62, 82), (62, 83), (62, 86), (62, 88), (62, 89), (62, 91), (62, 95), (62, 96), (63, 66), (63, 67), (63, 71), (63, 72), (63, 73), (63, 74), (63, 75), (63, 77), (63, 78), (63, 86), (63, 91), (63, 94), (63, 97), (63, 98), (63, 99), (64, 65), (64, 75), (64, 76), (64, 77), (64, 79), (64, 82), (64, 84), (64, 85), (64, 86), (64, 88), (64, 90), (64, 91), (64, 92), (64, 95), (64, 96), (64, 98), (65, 69), (65, 74), (65, 78), (65, 79), (65, 80), (65, 82), (65, 84), (65, 85), (65, 86), (65, 91), (65, 92), (65, 97), (66, 67), (66, 69), (66, 70), (66, 72), (66, 73), (66, 74), (66, 77), (66, 78), (66, 79), (66, 81), (66, 83), (66, 85), (66, 86), (66, 88), (66, 89), (66, 90), (66, 91), (66, 94), (66, 95), (66, 96), (66, 97), (67, 68), (67, 70), (67, 71), (67, 76), (67, 77), (67, 78), (67, 79), (67, 82), (67, 84), (67, 85), (67, 89), (67, 90), (67, 91), (67, 92), (67, 94), (67, 95), (67, 96), (67, 98), (67, 99), (68, 69), (68, 70), (68, 71), (68, 72), (68, 74), (68, 75), (68, 76), (68, 78), (68, 86), (68, 87), (68, 88), (68, 92), (68, 94), (68, 95), (68, 96), (68, 97), (69, 71), (69, 72), (69, 73), (69, 74), (69, 76), (69, 78), (69, 79), (69, 80), (69, 82), (69, 84), (69, 85), (69, 86), (69, 88), (69, 90), (69, 91), (69, 92), (69, 97), (69, 98), (70, 71), (70, 75), (70, 80), (70, 82), (70, 84), (70, 85), (70, 86), (70, 88), (70, 89), (70, 90), (70, 93), (70, 94), (70, 96), (70, 97), (70, 98), (71, 74), (71, 76), (71, 77), (71, 79), (71, 80), (71, 83), (71, 89), (71, 90), (71, 94), (71, 95), (71, 96), (71, 98), (71, 99), (72, 73), (72, 77), (72, 81), (72, 84), (72, 85), (72, 86), (72, 87), (72, 88), (72, 90), (72, 91), (72, 95), (72, 96), (72, 97), (72, 98), (72, 99), (73, 74), (73, 75), (73, 78), (73, 79), (73, 82), (73, 84), (73, 87), (73, 89), (73, 94), (73, 98), (73, 99), (74, 76), (74, 78), (74, 82), (74, 84), (74, 87), (74, 88), (74, 89), (74, 91), (74, 93), (74, 95), (74, 99), (75, 76), (75, 77), (75, 84), (75, 88), (75, 90), (75, 92), (75, 93), (75, 94), (75, 98), (75, 99), (76, 77), (76, 78), (76, 79), (76, 85), (76, 87), (76, 88), (76, 90), (76, 93), (77, 78), (77, 79), (77, 82), (77, 87), (77, 88), (77, 90), (77, 92), (77, 95), (77, 96), (77, 98), (78, 80), (78, 81), (78, 83), (78, 85), (78, 86), (78, 88), (78, 89), (78, 95), (78, 96), (78, 97), (78, 98), (79, 80), (79, 84), (79, 85), (79, 87), (79, 88), (79, 90), (79, 91), (79, 95), (79, 96), (79, 97), (80, 83), (80, 84), (80, 86), (80, 88), (80, 90), (80, 92), (80, 94), (80, 95), (80, 96), (81, 84), (81, 85), (81, 87), (81, 88), (81, 90), (81, 91), (81, 92), (82, 83), (82, 85), (82, 87), (82, 90), (82, 91), (82, 93), (82, 95), (83, 84), (83, 86), (83, 89), (83, 90), (83, 91), (83, 93), (83, 94), (83, 96), (83, 98), (84, 85), (84, 87), (84, 89), (84, 91), (84, 92), (84, 93), (84, 97), (84, 98), (85, 90), (85, 93), (85, 95), (85, 96), (86, 91), (86, 93), (86, 94), (86, 96), (86, 97), (87, 88), (87, 90), (87, 91), (87, 92), (87, 93), (87, 94), (87, 95), (87, 96), (87, 97), (87, 98), (87, 99), (88, 90), (88, 91), (88, 94), (88, 95), (88, 96), (88, 97), (88, 98), (88, 99), (89, 90), (89, 91), (89, 92), (89, 94), (89, 96), (89, 98), (90, 92), (90, 94), (90, 95), (90, 96), (91, 92), (91, 93), (91, 94), (91, 95), (91, 96), (92, 95), (92, 99), (93, 96), (94, 98), (95, 96), (96, 97), (97, 98)])
# g.add_edges_from([[0, 5], [0, 9], [0, 10], [0, 25], [0, 51], [0, 56], [0, 69], [0, 79], [0, 81], [0, 91], [0, 110], [1, 4], [1, 26], [1, 98], [1, 104], [1, 122], [1, 177], [1, 184], [1, 238], [1, 251], [2, 9], [2, 23], [2, 26], [2, 48], [2, 54], [2, 56], [2, 98], [2, 223], [3, 14], [3, 18], [3, 36], [3, 42], [3, 146], [3, 165], [4, 17], [4, 22], [4, 26], [4, 158], [4, 237], [4, 238], [5, 10], [5, 36], [5, 38], [5, 51], [5, 55], [5, 59], [5, 127], [5, 146], [5, 172], [6, 34], [6, 134], [6, 149], [6, 190], [6, 222], [7, 55], [7, 65], [7, 74], [7, 82], [7, 96], [7, 165], [7, 178], [8, 10], [8, 18], [8, 20], [8, 30], [8, 36], [8, 41], [8, 81], [8, 166], [8, 182], [9, 20], [9, 33], [9, 38], [9, 47], [9, 69], [9, 81], [9, 120], [9, 159], [9, 221], [9, 223], [10, 20], [10, 49], [10, 51], [10, 75], [10, 115], [10, 153], [10, 166], [10, 199], [11, 13], [11, 18], [11, 21], [11, 22], [11, 37], [11, 49], [11, 96], [11, 165], [11, 166], [11, 237], [12, 185], [13, 16], [13, 41], [13, 75], [13, 96], [13, 122], [13, 166], [13, 184], [13, 207], [14, 18], [14, 21], [14, 27], [14, 31], [14, 43], [14, 50], [14, 118], [14, 119], [14, 182], [15, 70], [15, 127], [15, 205], [15, 229], [15, 240], [16, 20], [16, 37], [16, 41], [16, 44], [16, 47], [16, 71], [16, 75], [16, 100], [16, 140], [16, 144], [16, 241], [17, 25], [17, 56], [17, 111], [17, 158], [17, 177], [17, 189], [17, 229], [18, 30], [18, 37], [18, 41], [18, 49], [19, 35], [19, 137], [19, 182], [19, 196], [20, 33], [20, 34], [20, 37], [20, 38], [20, 54], [20, 136], [20, 144], [20, 166], [21, 22], [21, 31], [21, 93], [21, 119], [21, 165], [21, 178], [21, 207], [22, 25], [22, 65], [22, 69], [22, 122], [22, 165], [22, 216], [22, 221], [23, 26], [23, 56], [23, 81], [23, 97], [23, 104], [23, 105], [23, 138], [23, 158], [23, 208], [23, 209], [23, 231], [24, 121], [24, 147], [24, 150], [24, 167], [24, 199], [25, 49], [25, 67], [25, 79], [25, 91], [25, 119], [25, 146], [25, 189], [25, 221], [26, 56], [26, 64], [26, 69], [26, 99], [26, 102], [26, 103], [26, 126], [26, 156], [26, 204], [26, 238], [26, 244], [27, 28], [27, 118], [27, 158], [28, 31], [28, 39], [28, 171], [29, 45], [29, 173], [29, 230], [30, 41], [30, 50], [30, 80], [30, 96], [30, 115], [30, 135], [30, 144], [31, 33], [31, 37], [31, 44], [31, 119], [31, 129], [31, 171], [31, 212], [31, 221], [32, 48], [32, 154], [32, 179], [32, 247], [33, 35], [33, 38], [33, 44], [33, 51], [33, 58], [33, 93], [33, 129], [33, 182], [34, 35], [34, 54], [34, 100], [34, 134], [34, 139], [34, 160], [34, 164], [34, 223], [35, 139], [35, 171], [35, 196], [35, 223], [36, 38], [36, 42], [36, 55], [36, 81], [36, 137], [36, 182], [36, 209], [37, 49], [37, 144], [37, 221], [38, 55], [38, 71], [38, 82], [38, 139], [38, 145], [38, 206], [39, 44], [39, 98], [39, 133], [39, 140], [39, 155], [39, 200], [40, 117], [41, 42], [41, 43], [41, 68], [41, 75], [41, 90], [41, 162], [41, 220], [42, 43], [42, 59], [42, 71], [42, 90], [42, 132], [42, 151], [42, 232], [43, 44], [43, 50], [43, 53], [43, 90], [43, 182], [43, 207], [44, 47], [44, 53], [44, 71], [44, 129], [44, 207], [45, 63], [45, 64], [45, 123], [45, 175], [45, 197], [45, 204], [46, 98], [46, 107], [46, 155], [46, 174], [46, 239], [46, 247], [47, 71], [47, 79], [47, 90], [47, 98], [47, 113], [47, 122], [47, 159], [47, 221], [47, 248], [48, 105], [48, 149], [48, 154], [48, 170], [48, 204], [48, 222], [48, 247], [49, 75], [49, 87], [49, 115], [49, 119], [49, 146], [50, 80], [50, 129], [50, 178], [50, 182], [51, 53], [51, 60], [51, 93], [51, 94], [51, 119], [51, 182], [51, 196], [52, 83], [52, 110], [52, 152], [52, 170], [53, 59], [53, 75], [53, 76], [53, 79], [53, 119], [53, 133], [53, 207], [54, 140], [54, 149], [54, 199], [54, 244], [55, 63], [55, 64], [55, 69], [55, 93], [55, 95], [55, 165], [55, 166], [55, 227], [56, 73], [56, 94], [56, 127], [56, 147], [56, 170], [56, 177], [56, 199], [56, 229], [57, 215], [57, 217], [57, 243], [58, 145], [59, 71], [59, 75], [59, 79], [59, 146], [59, 205], [60, 121], [60, 224], [61, 63], [61, 66], [61, 69], [61, 83], [61, 109], [61, 110], [61, 194], [61, 204], [61, 216], [63, 66], [63, 145], [63, 173], [64, 95], [64, 102], [64, 127], [64, 209], [64, 227], [64, 244], [65, 69], [65, 80], [65, 91], [65, 96], [65, 122], [65, 159], [65, 178], [65, 238], [66, 123], [66, 166], [66, 225], [67, 108], [67, 110], [67, 111], [67, 216], [68, 100], [68, 143], [68, 162], [68, 220], [69, 81], [69, 93], [69, 103], [69, 122], [69, 126], [69, 166], [69, 194], [70, 82], [70, 179], [70, 200], [70, 240], [71, 82], [71, 114], [71, 157], [71, 176], [71, 200], [72, 100], [72, 134], [72, 193], [72, 241], [73, 97], [73, 147], [73, 156], [73, 170], [73, 192], [73, 215], [74, 195], [74, 227], [75, 79], [75, 115], [75, 191], [76, 133], [76, 161], [76, 196], [76, 233], [77, 88], [77, 106], [79, 90], [79, 91], [79, 122], [79, 161], [79, 177], [80, 81], [80, 90], [80, 91], [80, 101], [80, 138], [80, 159], [80, 187], [81, 90], [81, 182], [81, 231], [82, 128], [82, 129], [82, 144], [82, 159], [83, 92], [83, 103], [83, 204], [84, 232], [85, 89], [85, 198], [85, 236], [85, 251], [88, 105], [88, 108], [88, 111], [88, 154], [88, 158], [89, 143], [89, 174], [89, 198], [89, 246], [90, 104], [90, 122], [90, 143], [91, 115], [91, 159], [91, 229], [92, 99], [92, 103], [92, 194], [93, 102], [93, 166], [93, 178], [93, 182], [93, 207], [94, 102], [94, 121], [94, 127], [94, 133], [94, 192], [94, 196], [94, 199], [95, 126], [95, 137], [95, 139], [95, 164], [95, 168], [95, 214], [95, 227], [96, 115], [96, 144], [96, 166], [96, 178], [96, 195], [96, 226], [96, 245], [97, 105], [97, 156], [97, 163], [97, 208], [98, 104], [98, 113], [98, 140], [98, 177], [98, 200], [98, 247], [98, 248], [99, 147], [99, 156], [99, 180], [99, 194], [99, 204], [99, 208], [100, 114], [100, 140], [100, 160], [100, 248], [101, 187], [102, 175], [102, 180], [102, 228], [102, 244], [103, 126], [103, 227], [103, 231], [104, 132], [104, 138], [104, 143], [104, 158], [104, 162], [104, 174], [104, 177], [105, 170], [105, 204], [105, 208], [106, 162], [106, 181], [107, 140], [107, 155], [107, 239], [108, 187], [108, 216], [109, 122], [109, 173], [109, 216], [109, 236], [110, 152], [110, 170], [111, 117], [111, 141], [111, 154], [111, 170], [112, 210], [113, 202], [113, 248], [114, 139], [114, 200], [114, 219], [114, 248], [115, 144], [116, 145], [116, 183], [116, 186], [116, 190], [116, 206], [117, 131], [119, 146], [120, 194], [121, 147], [121, 167], [121, 180], [121, 192], [121, 224], [122, 207], [122, 236], [122, 251], [123, 149], [123, 150], [123, 175], [123, 204], [123, 244], [125, 154], [125, 201], [126, 164], [126, 203], [126, 223], [126, 251], [127, 167], [127, 172], [127, 197], [127, 199], [127, 205], [127, 209], [128, 145], [128, 176], [128, 179], [129, 144], [129, 159], [129, 178], [130, 213], [132, 151], [132, 162], [132, 200], [132, 205], [132, 209], [132, 240], [133, 177], [133, 191], [133, 205], [134, 136], [135, 138], [135, 162], [135, 240], [136, 153], [136, 241], [137, 139], [137, 209], [137, 242], [138, 158], [138, 229], [138, 238], [138, 240], [139, 206], [139, 223], [140, 162], [140, 184], [140, 191], [140, 200], [141, 170], [141, 177], [141, 247], [142, 183], [142, 186], [142, 210], [143, 161], [143, 246], [143, 248], [143, 251], [144, 159], [144, 160], [145, 176], [146, 165], [146, 211], [147, 167], [147, 170], [147, 208], [148, 211], [149, 150], [149, 190], [150, 170], [150, 197], [150, 199], [151, 220], [152, 170], [152, 215], [152, 222], [152, 243], [154, 247], [155, 213], [155, 239], [155, 250], [156, 203], [156, 204], [157, 176], [157, 232], [157, 241], [159, 221], [161, 177], [161, 198], [161, 248], [161, 251], [162, 184], [162, 191], [162, 220], [164, 166], [164, 244], [165, 168], [166, 225], [166, 244], [167, 197], [167, 217], [169, 175], [170, 197], [170, 204], [171, 188], [172, 206], [172, 227], [173, 176], [174, 208], [175, 180], [175, 204], [176, 219], [176, 230], [177, 191], [177, 205], [177, 229], [178, 207], [178, 228], [179, 230], [183, 210], [184, 191], [184, 237], [184, 244], [186, 206], [188, 202], [188, 221], [188, 223], [188, 248], [189, 202], [191, 199], [191, 205], [194, 225], [194, 236], [196, 224], [196, 233], [197, 243], [199, 244], [200, 205], [200, 230], [200, 239], [202, 221], [203, 215], [203, 218], [206, 227], [209, 240], [210, 242], [213, 250], [214, 217], [214, 242], [217, 224], [217, 242], [217, 243], [219, 230], [222, 223], [223, 248], [225, 245], [226, 245], [228, 238], [229, 238], [230, 239], [230, 247], [237, 244], [248, 251]])
g = nx.random_partition_graph(partition_sizes, 0.5, 0.1)
# since we created the graph, we know the best partition:
print(g.nodes)
node_to_community = dict()
node = 0
for community_id, size in enumerate(partition_sizes):
    for _ in range(size):
        node_to_community[node] = community_id
        node += 1
print(node_to_community)
# itsdan = {0: [0, 5, 9, 10, 25, 51, 56, 69, 79, 81, 91, 110, 36, 38, 55, 59, 127, 146, 172, 2, 20, 33, 47, 120, 159, 221, 223, 8, 49, 75, 115, 153, 166, 199, 17, 22, 67, 119, 189, 53, 60, 93, 94, 182, 196, 23, 26, 73, 147, 170, 177, 229, 61, 65, 103, 122, 126, 194, 90, 161, 80, 231, 52, 152, 3, 42, 137, 209, 71, 82, 139, 145, 206, 7, 63, 64, 95, 165, 227, 205, 15, 167, 197, 211, 48, 54, 98, 16, 34, 37, 136, 144, 31, 35, 44, 58, 129, 113, 248, 188, 202, 222, 18, 30, 41, 11, 87, 13, 191, 96, 66, 164, 225, 244, 24, 150, 4, 111, 158, 21, 216, 108, 14, 43, 76, 133, 207, 121, 224, 102, 178, 192, 19, 50, 233, 97, 104, 105, 138, 208, 1, 99, 156, 204, 238, 215, 141, 83, 109, 92, 236, 251, 203, 143, 198, 101, 187, 243, 132, 151, 232, 242, 240, 114, 157, 176, 200, 70, 128, 116, 186, 74, 45, 173, 168, 214, 217, 148, 32, 149, 154, 247, 140, 39, 46, 100, 241, 6, 134, 160, 28, 171, 212, 135, 68, 162, 220, 237, 184, 195, 226, 245, 123, 88, 117, 27, 118, 180, 175, 228, 163, 174, 57, 85, 218, 89, 246, 84, 210, 219, 230, 239, 179, 183, 190, 142, 29, 125, 107, 155, 72, 106, 77, 40, 131, 169, 112, 201, 213, 250, 193, 181, 130], 1: [12, 185], 2: [62], 3: [78], 4: [86], 5: [124], 6: [234], 7: [235], 8: [249]}
asdsss = {}
asdsss_colors = {}
# for k, v in itsdan.items():
#     for j in v:
#         asdsss[j] = k
#         asdsss_colors[j] = 'tab:' + colors[k]

for k, v in node_to_community.items():
    asdsss_colors[k] = 'tab:' + colors[v]
print(asdsss_colors)
# # alternatively, we can infer the best partition using Louvain:

community_to_color = {
    0 : 'tab:blue',
    1 : 'tab:orange',
    2 : 'tab:green',
    3 : 'tab:red',
}
# node_color = {node: community_to_color[community_id] for node, community_id in node_to_community.items()}
# print(node_color)
